#pragma once

#include "CoreMinimal.h"
#include "Engine/DataAsset.h"
#include "GameplayTagContainer.h"
#include "KillerAbilityData.generated.h"

class UAkAudioEvent;

UCLASS(Blueprintable)
class DBDGAMEPLAY_API UKillerAbilityData : public UDataAsset
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _cooldown;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _startsOnCooldown;

	UPROPERTY(EditAnywhere)
	FGameplayTag _cooldownStateTag;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _duration;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _isTokenBased;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	int32 _startTokenCount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	int32 _maxTokenCount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _shouldAutomaticallyRechargeTokens;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _timeRequiredToChargeToken;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _availabilityRequiresAToken;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UAkAudioEvent* _onCooldownCompletedAkEvent;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UAkAudioEvent* _onTokenAddedAkEvent;

public:
	UFUNCTION(BlueprintPure)
	float GetDuration() const;

	UFUNCTION(BlueprintPure)
	float GetCooldown() const;

public:
	UKillerAbilityData();
};

FORCEINLINE uint32 GetTypeHash(const UKillerAbilityData) { return 0; }
